import socket
import sys
import struct

#
# This class shows how to use the start stop switch for a CODESYS control runtime
# you can just write "RUN" or "STOP" into the file: "/var/opt/codesysextension/runstop.switch"
# this triggers the RUN or STOP of the runtime
#
class CODESYS_StartStopSwitch():
    def __init__(self):
        self.switch = "/var/opt/codesysextension/runstop.switch"
        

    def start(self):
        with open(self.switch, "w") as s:
             s.write("RUN")

    def stop(self):
         with open(self.switch, "w") as s:
             s.write("STOP")

# example for start stop switch :
if __name__ == "__main__":

    for arg in sys.argv:
        if arg == "start":
            myStartStopSwitch = CODESYS_StartStopSwitch()
            myStartStopSwitch.start()
        elif arg == "stop":
            myStartStopSwitch = CODESYS_StartStopSwitch()
            myStartStopSwitch.stop()

    